# ``trie`::node_iterator` Interface

Node iterator.

This is an "iterator to an iterator" - it iterates over nodes, and de-referencing it returns one of the tree's iterators

## Base Classes

Class | Derivation Type

    trie::const_node_iterator

public

## Public Types and Constants

### General Container Definitions

Type | Definition | Description

    size_type

    typename trie::const_node_iterator::size_type

Size type.

### Value-Type Definitions

Type | Definition | Description

    value_type

    container_base::iterator

Iterator's value type.

    reference

    value_type

Iterator's reference type.

    const_reference

    value_type

Iterator's const `reference` type.

## Public Methods

### Constructors, Destructor, and Related

Method | Description

    inline
      pat_trie_node_it_
      ()

Default constructor.

### Access Methods

Method | Description

    inline reference
      operator*
      () const

Access; returns the iterator associated with the current leaf.

Should be called only for leaf nodes.

### Movement Methods

Method | Description

    node_iterator
      get_child
      (size_type i) const

Returns a node iterator to the corresponding node's `i`-th child.